package model

type User struct {
	Uuid     string `json:"uuid" gorm:"<-:create;size:64;not null;comment:uuid"`
	Username string `json:"username" gorm:"size:64;not null;comment:用户名"` // 用户名
	Password string `json:"-" gorm:"size:128;comment:密码"`                 // 密码
	NickName string `json:"nickName" gorm:"size:128;comment:昵称"`          // 昵称
	Phone    string `json:"phone" gorm:"size:11;not null;comment:手机号"`    // 手机号
	RoleId   int    `json:"roleId" gorm:"comment:角色ID"`                   // 角色id
	Salt     string `json:"-" gorm:"size:255;comment:加盐"`
	DeptId   int    `json:"deptId" gorm:"comment:部门"`                             // 部门id
	PostId   int    `json:"postId" gorm:"comment:岗位"`                             // 岗位id
	Remark   string `json:"remark" gorm:"size:255;comment:备注"`                    // 备注
	Status   string `json:"status" gorm:"size:4;not null;default:'2';comment:状态"` // 1-停用 2-正常
}

type UserInfo struct {
	Uuid      string `json:"uuid"`      // 用户uuid
	UserId    int    `json:"userId"`    // 用户id
	RoleId    int    `json:"roleId"`    // 角色id
	DeptId    int    `json:"deptId"`    // 部门id
	UserName  string `json:"userName"`  // 用户名称
	RoleName  string `json:"roleName"`  // 角色名称
	DeptName  string `json:"deptName"`  // 部门名称
	RoleKey   string `json:"roleKey"`   // 角色编码
	DataScope int    `json:"dataScope"` // 数据访问范围 1-全部数据权限 3-本机构数据权限  4-本机构及以下数据权限 5-仅本人数据权限
}
